doc: do not use `rm .git/index` when normalizing line endings
[git/git.git] / git-stash.sh
1 #!/bin/sh
2 # Copyright (c) 2007, Nanako Shiraishi
3
4 dashless=$(basename "$0" | sed -e 's/-/ /')
5 USAGE="list [<options>]
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9 or: $dashless branch <branchname> [<stash>]
10 or: $dashless save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
11 [-u|--include-untracked] [-a|--all] [<message>]
12 or: $dashless [push [--patch] [-k|--[no-]keep-index] [-q|--quiet]
13 [-u|--include-untracked] [-a|--all] [-m <message>]
14 [-- <pathspec>...]]
15 or: $dashless clear"
16
17 SUBDIRECTORY_OK=Yes
18 OPTIONS_SPEC=
19 START_DIR=$(pwd)
20 . git-sh-setup
21 require_work_tree
22 cd_to_toplevel
23
24 TMP="$GIT_DIR/.git-stash.$$"
25 TMPindex=${GIT_INDEX_FILE-"$(git rev-parse --git-path index)"}.stash.$$
26 trap 'rm -f "$TMP-"* "$TMPindex"' 0
27
28 ref_stash=refs/stash
29
30 if git config --get-colorbool color.interactive; then
31 help_color="$(git config --get-color color.interactive.help 'red bold')"
32 reset_color="$(git config --get-color '' reset)"
33 else
34 help_color=
35 reset_color=
36 fi
37
38 no_changes () {
39 git diff-index --quiet --cached HEAD --ignore-submodules -- "$@" &&
40 git diff-files --quiet --ignore-submodules -- "$@" &&
41 (test -z "$untracked" || test -z "$(untracked_files)")
42 }
43
44 untracked_files () {
45 excl_opt=--exclude-standard
46 test "$untracked" = "all" && excl_opt=
47 git ls-files -o -z $excl_opt -- "$@"
48 }
49
50 clear_stash () {
51 if test $# != 0
52 then
53 die "$(gettext "git stash clear with parameters is unimplemented")"
54 fi
55 if current=$(git rev-parse --verify --quiet $ref_stash)
56 then
57 git update-ref -d $ref_stash $current
58 fi
59 }
60
61 create_stash () {
62 stash_msg=
63 untracked=
64 while test $# != 0
65 do
66 case "$1" in
67 -m|--message)
68 shift
69 stash_msg=${1?"BUG: create_stash () -m requires an argument"}
70 ;;
71 -u|--include-untracked)
72 shift
73 untracked=${1?"BUG: create_stash () -u requires an argument"}
74 ;;
75 --)
76 shift
77 break
78 ;;
79 esac
80 shift
81 done
82
83 git update-index -q --refresh
84 if no_changes "$@"
85 then
86 exit 0
87 fi
88
89 # state of the base commit
90 if b_commit=$(git rev-parse --verify HEAD)
91 then
92 head=$(git rev-list --oneline -n 1 HEAD --)
93 else
94 die "$(gettext "You do not have the initial commit yet")"
95 fi
96
97 if branch=$(git symbolic-ref -q HEAD)
98 then
99 branch=${branch#refs/heads/}
100 else
101 branch='(no branch)'
102 fi
103 msg=$(printf '%s: %s' "$branch" "$head")
104
105 # state of the index
106 i_tree=$(git write-tree) &&
107 i_commit=$(printf 'index on %s\n' "$msg" |
108 git commit-tree $i_tree -p $b_commit) ||
109 die "$(gettext "Cannot save the current index state")"
110
111 if test -n "$untracked"
112 then
113 # Untracked files are stored by themselves in a parentless commit, for
114 # ease of unpacking later.
115 u_commit=$(
116 untracked_files "$@" | (
117 GIT_INDEX_FILE="$TMPindex" &&
118 export GIT_INDEX_FILE &&
119 rm -f "$TMPindex" &&
120 git update-index -z --add --remove --stdin &&
121 u_tree=$(git write-tree) &&
122 printf 'untracked files on %s\n' "$msg" | git commit-tree $u_tree &&
123 rm -f "$TMPindex"
124 ) ) || die "$(gettext "Cannot save the untracked files")"
125
126 untracked_commit_option="-p $u_commit";
127 else
128 untracked_commit_option=
129 fi
130
131 if test -z "$patch_mode"
132 then
133
134 # state of the working tree
135 w_tree=$( (
136 git read-tree --index-output="$TMPindex" -m $i_tree &&
137 GIT_INDEX_FILE="$TMPindex" &&
138 export GIT_INDEX_FILE &&
139 git diff-index --name-only -z HEAD -- "$@" >"$TMP-stagenames" &&
140 git update-index -z --add --remove --stdin <"$TMP-stagenames" &&
141 git write-tree &&
142 rm -f "$TMPindex"
143 ) ) ||
144 die "$(gettext "Cannot save the current worktree state")"
145
146 else
147
148 rm -f "$TMP-index" &&
149 GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
150
151 # find out what the user wants
152 GIT_INDEX_FILE="$TMP-index" \
153 git add--interactive --patch=stash -- "$@" &&
154
155 # state of the working tree
156 w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
157 die "$(gettext "Cannot save the current worktree state")"
158
159 git diff-tree -p HEAD $w_tree -- >"$TMP-patch" &&
160 test -s "$TMP-patch" ||
161 die "$(gettext "No changes selected")"
162
163 rm -f "$TMP-index" ||
164 die "$(gettext "Cannot remove temporary index (can't happen)")"
165
166 fi
167
168 # create the stash
169 if test -z "$stash_msg"
170 then
171 stash_msg=$(printf 'WIP on %s' "$msg")
172 else
173 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
174 fi
175 w_commit=$(printf '%s\n' "$stash_msg" |
176 git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
177 die "$(gettext "Cannot record working tree state")"
178 }
179
180 store_stash () {
181 while test $# != 0
182 do
183 case "$1" in
184 -m|--message)
185 shift
186 stash_msg="$1"
187 ;;
188 -q|--quiet)
189 quiet=t
190 ;;
191 *)
192 break
193 ;;
194 esac
195 shift
196 done
197 test $# = 1 ||
198 die "$(eval_gettext "\"$dashless store\" requires one <commit> argument")"
199
200 w_commit="$1"
201 if test -z "$stash_msg"
202 then
203 stash_msg="Created via \"git stash store\"."
204 fi
205
206 git update-ref --create-reflog -m "$stash_msg" $ref_stash $w_commit
207 ret=$?
208 test $ret != 0 && test -z "$quiet" &&
209 die "$(eval_gettext "Cannot update \$ref_stash with \$w_commit")"
210 return $ret
211 }
212
213 push_stash () {
214 keep_index=
215 patch_mode=
216 untracked=
217 stash_msg=
218 while test $# != 0
219 do
220 case "$1" in
221 -k|--keep-index)
222 keep_index=t
223 ;;
224 --no-keep-index)
225 keep_index=n
226 ;;
227 -p|--patch)
228 patch_mode=t
229 # only default to keep if we don't already have an override
230 test -z "$keep_index" && keep_index=t
231 ;;
232 -q|--quiet)
233 GIT_QUIET=t
234 ;;
235 -u|--include-untracked)
236 untracked=untracked
237 ;;
238 -a|--all)
239 untracked=all
240 ;;
241 -m|--message)
242 shift
243 test -z ${1+x} && usage
244 stash_msg=$1
245 ;;
246 --help)
247 show_help
248 ;;
249 --)
250 shift
251 break
252 ;;
253 -*)
254 option="$1"
255 # TRANSLATORS: $option is an invalid option, like
256 # `--blah-blah'. The 7 spaces at the beginning of the
257 # second line correspond to "error: ". So you should line
258 # up the second line with however many characters the
259 # translation of "error: " takes in your language. E.g. in
260 # English this is:
261 #
262 # $ git stash save --blah-blah 2>&1 | head -n 2
263 # error: unknown option for 'stash save': --blah-blah
264 # To provide a message, use git stash save -- '--blah-blah'
265 eval_gettextln "error: unknown option for 'stash save': \$option
266 To provide a message, use git stash save -- '\$option'"
267 usage
268 ;;
269 *)
270 break
271 ;;
272 esac
273 shift
274 done
275
276 if test -n "$patch_mode" && test -n "$untracked"
277 then
278 die "$(gettext "Can't use --patch and --include-untracked or --all at the same time")"
279 fi
280
281 test -n "$untracked" || git ls-files --error-unmatch -- "$@" >/dev/null || exit 1
282
283 git update-index -q --refresh
284 if no_changes "$@"
285 then
286 say "$(gettext "No local changes to save")"
287 exit 0
288 fi
289
290 git reflog exists $ref_stash ||
291 clear_stash || die "$(gettext "Cannot initialize stash")"
292
293 create_stash -m "$stash_msg" -u "$untracked" -- "$@"
294 store_stash -m "$stash_msg" -q $w_commit ||
295 die "$(gettext "Cannot save the current status")"
296 say "$(eval_gettext "Saved working directory and index state \$stash_msg")"
297
298 if test -z "$patch_mode"
299 then
300 if test $# != 0
301 then
302 git reset -q -- "$@"
303 git ls-files -z --modified -- "$@" |
304 git checkout-index -z --force --stdin
305 git clean --force -q -d -- "$@"
306 else
307 git reset --hard -q
308 fi
309 test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION=
310 if test -n "$untracked"
311 then
312 git clean --force --quiet -d $CLEAN_X_OPTION -- "$@"
313 fi
314
315 if test "$keep_index" = "t" && test -n "$i_tree"
316 then
317 git read-tree --reset $i_tree
318 git ls-files -z --modified -- "$@" |
319 git checkout-index -z --force --stdin
320 fi
321 else
322 git apply -R < "$TMP-patch" ||
323 die "$(gettext "Cannot remove worktree changes")"
324
325 if test "$keep_index" != "t"
326 then
327 git reset -q -- "$@"
328 fi
329 fi
330 }
331
332 save_stash () {
333 push_options=
334 while test $# != 0
335 do
336 case "$1" in
337 --)
338 shift
339 break
340 ;;
341 -*)
342 # pass all options through to push_stash
343 push_options="$push_options $1"
344 ;;
345 *)
346 break
347 ;;
348 esac
349 shift
350 done
351
352 stash_msg="$*"
353
354 if test -z "$stash_msg"
355 then
356 push_stash $push_options
357 else
358 push_stash $push_options -m "$stash_msg"
359 fi
360 }
361
362 have_stash () {
363 git rev-parse --verify --quiet $ref_stash >/dev/null
364 }
365
366 list_stash () {
367 have_stash || return 0
368 git log --format="%gd: %gs" -g --first-parent -m "$@" $ref_stash --
369 }
370
371 show_stash () {
372 ALLOW_UNKNOWN_FLAGS=t
373 assert_stash_like "$@"
374
375 if test -z "$FLAGS"
376 then
377 if test "$(git config --bool stash.showStat || echo true)" = "true"
378 then
379 FLAGS=--stat
380 fi
381
382 if test "$(git config --bool stash.showPatch || echo false)" = "true"
383 then
384 FLAGS=${FLAGS}${FLAGS:+ }-p
385 fi
386
387 if test -z "$FLAGS"
388 then
389 return 0
390 fi
391 fi
392
393 git diff ${FLAGS} $b_commit $w_commit
394 }
395
396 show_help () {
397 exec git help stash
398 exit 1
399 }
400
401 #
402 # Parses the remaining options looking for flags and
403 # at most one revision defaulting to ${ref_stash}@{0}
404 # if none found.
405 #
406 # Derives related tree and commit objects from the
407 # revision, if one is found.
408 #
409 # stash records the work tree, and is a merge between the
410 # base commit (first parent) and the index tree (second parent).
411 #
412 # REV is set to the symbolic version of the specified stash-like commit
413 # IS_STASH_LIKE is non-blank if ${REV} looks like a stash
414 # IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
415 # s is set to the SHA1 of the stash commit
416 # w_commit is set to the commit containing the working tree
417 # b_commit is set to the base commit
418 # i_commit is set to the commit containing the index tree
419 # u_commit is set to the commit containing the untracked files tree
420 # w_tree is set to the working tree
421 # b_tree is set to the base tree
422 # i_tree is set to the index tree
423 # u_tree is set to the untracked files tree
424 #
425 # GIT_QUIET is set to t if -q is specified
426 # INDEX_OPTION is set to --index if --index is specified.
427 # FLAGS is set to the remaining flags (if allowed)
428 #
429 # dies if:
430 # * too many revisions specified
431 # * no revision is specified and there is no stash stack
432 # * a revision is specified which cannot be resolve to a SHA1
433 # * a non-existent stash reference is specified
434 # * unknown flags were set and ALLOW_UNKNOWN_FLAGS is not "t"
435 #
436
437 parse_flags_and_rev()
438 {
439 test "$PARSE_CACHE" = "$*" && return 0 # optimisation
440 PARSE_CACHE="$*"
441
442 IS_STASH_LIKE=
443 IS_STASH_REF=
444 INDEX_OPTION=
445 s=
446 w_commit=
447 b_commit=
448 i_commit=
449 u_commit=
450 w_tree=
451 b_tree=
452 i_tree=
453 u_tree=
454
455 FLAGS=
456 REV=
457 for opt
458 do
459 case "$opt" in
460 -q|--quiet)
461 GIT_QUIET=-t
462 ;;
463 --index)
464 INDEX_OPTION=--index
465 ;;
466 --help)
467 show_help
468 ;;
469 -*)
470 test "$ALLOW_UNKNOWN_FLAGS" = t ||
471 die "$(eval_gettext "unknown option: \$opt")"
472 FLAGS="${FLAGS}${FLAGS:+ }$opt"
473 ;;
474 *)
475 REV="${REV}${REV:+ }'$opt'"
476 ;;
477 esac
478 done
479
480 eval set -- $REV
481
482 case $# in
483 0)
484 have_stash || die "$(gettext "No stash found.")"
485 set -- ${ref_stash}@{0}
486 ;;
487 1)
488 :
489 ;;
490 *)
491 die "$(eval_gettext "Too many revisions specified: \$REV")"
492 ;;
493 esac
494
495 case "$1" in
496 *[!0-9]*)
497 :
498 ;;
499 *)
500 set -- "${ref_stash}@{$1}"
501 ;;
502 esac
503
504 REV=$(git rev-parse --symbolic --verify --quiet "$1") || {
505 reference="$1"
506 die "$(eval_gettext "\$reference is not a valid reference")"
507 }
508
509 i_commit=$(git rev-parse --verify --quiet "$REV^2") &&
510 set -- $(git rev-parse "$REV" "$REV^1" "$REV:" "$REV^1:" "$REV^2:" 2>/dev/null) &&
511 s=$1 &&
512 w_commit=$1 &&
513 b_commit=$2 &&
514 w_tree=$3 &&
515 b_tree=$4 &&
516 i_tree=$5 &&
517 IS_STASH_LIKE=t &&
518 test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
519 IS_STASH_REF=t
520
521 u_commit=$(git rev-parse --verify --quiet "$REV^3") &&
522 u_tree=$(git rev-parse "$REV^3:" 2>/dev/null)
523 }
524
525 is_stash_like()
526 {
527 parse_flags_and_rev "$@"
528 test -n "$IS_STASH_LIKE"
529 }
530
531 assert_stash_like() {
532 is_stash_like "$@" || {
533 args="$*"
534 die "$(eval_gettext "'\$args' is not a stash-like commit")"
535 }
536 }
537
538 is_stash_ref() {
539 is_stash_like "$@" && test -n "$IS_STASH_REF"
540 }
541
542 assert_stash_ref() {
543 is_stash_ref "$@" || {
544 args="$*"
545 die "$(eval_gettext "'\$args' is not a stash reference")"
546 }
547 }
548
549 apply_stash () {
550
551 assert_stash_like "$@"
552
553 git update-index -q --refresh || die "$(gettext "unable to refresh index")"
554
555 # current index state
556 c_tree=$(git write-tree) ||
557 die "$(gettext "Cannot apply a stash in the middle of a merge")"
558
559 unstashed_index_tree=
560 if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
561 test "$c_tree" != "$i_tree"
562 then
563 git diff-tree --binary $s^2^..$s^2 | git apply --cached
564 test $? -ne 0 &&
565 die "$(gettext "Conflicts in index. Try without --index.")"
566 unstashed_index_tree=$(git write-tree) ||
567 die "$(gettext "Could not save index tree")"
568 git reset
569 fi
570
571 if test -n "$u_tree"
572 then
573 GIT_INDEX_FILE="$TMPindex" git-read-tree "$u_tree" &&
574 GIT_INDEX_FILE="$TMPindex" git checkout-index --all &&
575 rm -f "$TMPindex" ||
576 die "$(gettext "Could not restore untracked files from stash")"
577 fi
578
579 eval "
580 GITHEAD_$w_tree='Stashed changes' &&
581 GITHEAD_$c_tree='Updated upstream' &&
582 GITHEAD_$b_tree='Version stash was based on' &&
583 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
584 "
585
586 if test -n "$GIT_QUIET"
587 then
588 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
589 fi
590 if git merge-recursive $b_tree -- $c_tree $w_tree
591 then
592 # No conflict
593 if test -n "$unstashed_index_tree"
594 then
595 git read-tree "$unstashed_index_tree"
596 else
597 a="$TMP-added" &&
598 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
599 git read-tree --reset $c_tree &&
600 git update-index --add --stdin <"$a" ||
601 die "$(gettext "Cannot unstage modified files")"
602 rm -f "$a"
603 fi
604 squelch=
605 if test -n "$GIT_QUIET"
606 then
607 squelch='>/dev/null 2>&1'
608 fi
609 (cd "$START_DIR" && eval "git status $squelch") || :
610 else
611 # Merge conflict; keep the exit status from merge-recursive
612 status=$?
613 git rerere
614 if test -n "$INDEX_OPTION"
615 then
616 gettextln "Index was not unstashed." >&2
617 fi
618 exit $status
619 fi
620 }
621
622 pop_stash() {
623 assert_stash_ref "$@"
624
625 if apply_stash "$@"
626 then
627 drop_stash "$@"
628 else
629 status=$?
630 say "$(gettext "The stash is kept in case you need it again.")"
631 exit $status
632 fi
633 }
634
635 drop_stash () {
636 assert_stash_ref "$@"
637
638 git reflog delete --updateref --rewrite "${REV}" &&
639 say "$(eval_gettext "Dropped \${REV} (\$s)")" ||
640 die "$(eval_gettext "\${REV}: Could not drop stash entry")"
641
642 # clear_stash if we just dropped the last stash entry
643 git rev-parse --verify --quiet "$ref_stash@{0}" >/dev/null ||
644 clear_stash
645 }
646
647 apply_to_branch () {
648 test -n "$1" || die "$(gettext "No branch name specified")"
649 branch=$1
650 shift 1
651
652 set -- --index "$@"
653 assert_stash_like "$@"
654
655 git checkout -b $branch $REV^ &&
656 apply_stash "$@" && {
657 test -z "$IS_STASH_REF" || drop_stash "$@"
658 }
659 }
660
661 test "$1" = "-p" && set "push" "$@"
662
663 PARSE_CACHE='--not-parsed'
664 # The default command is "push" if nothing but options are given
665 seen_non_option=
666 for opt
667 do
668 case "$opt" in
669 --) break ;;
670 -*) ;;
671 *) seen_non_option=t; break ;;
672 esac
673 done
674
675 test -n "$seen_non_option" || set "push" "$@"
676
677 # Main command set
678 case "$1" in
679 list)
680 shift
681 list_stash "$@"
682 ;;
683 show)
684 shift
685 show_stash "$@"
686 ;;
687 save)
688 shift
689 save_stash "$@"
690 ;;
691 push)
692 shift
693 push_stash "$@"
694 ;;
695 apply)
696 shift
697 apply_stash "$@"
698 ;;
699 clear)
700 shift
701 clear_stash "$@"
702 ;;
703 create)
704 shift
705 create_stash -m "$*" && echo "$w_commit"
706 ;;
707 store)
708 shift
709 store_stash "$@"
710 ;;
711 drop)
712 shift
713 drop_stash "$@"
714 ;;
715 pop)
716 shift
717 pop_stash "$@"
718 ;;
719 branch)
720 shift
721 apply_to_branch "$@"
722 ;;
723 *)
724 case $# in
725 0)
726 push_stash &&
727 say "$(gettext "(To restore them type \"git stash apply\")")"
728 ;;
729 *)
730 usage
731 esac
732 ;;
733 esac